﻿Public Class Form1
    Dim palette8 As Imaging.ColorPalette
    Dim bmp4bpp As Bitmap
    Dim Vbar(7) As VScrollBar

    Private Sub ButOPEN_Click(sender As Object, e As EventArgs) Handles ButOPEN.Click
        Dim ofd As OpenFileDialog = New OpenFileDialog()
        ofd.Filter = "Images(*.bmp *.tif *.tiff *.gif)|*.bmp;*.tif;*.tiff; *.gif|Tutti i file (*.*)|*.*"
        ofd.RestoreDirectory = True
        If ofd.ShowDialog() = DialogResult.OK Then
            Me.Text = ofd.FileName
            Dim bmp8bpp As Bitmap = New Bitmap(ofd.FileName) ' in immagine l'immagine scelta
            Dim palette As Imaging.ColorPalette = bmp8bpp.Palette ' in palette, la palette dell'immagine scelta
            If palette.Entries.Length <> 256 Then
                LabINFO.Text = "ERRORE " & bmp8bpp.Width & "x" & bmp8bpp.Height & " " & bmp8bpp.PixelFormat.ToString & ", L' immagine non è a 8bpp"
                Exit Sub
            Else
                LabINFO.Text = bmp8bpp.Width & "x" & bmp8bpp.Height & " " & bmp8bpp.PixelFormat.ToString & ", L' immagine ha una palette da " & palette.Entries.Length & " colori"
            End If
            ' blocco i bit della bitmap     
            Dim area8 As Rectangle = New Rectangle(0, 0, bmp8bpp.Width, bmp8bpp.Height)
            Dim bmpData8 As System.Drawing.Imaging.BitmapData = bmp8bpp.LockBits(area8, Drawing.Imaging.ImageLockMode.ReadWrite, bmp8bpp.PixelFormat)
            Dim ptr8 As IntPtr = bmpData8.Scan0 ' puntatore all'indirizzo di memoria del primo byte.
            Dim bytes8 As Integer = Math.Abs(bmpData8.Stride) * bmp8bpp.Height ' calcolo dei bytes necessari
            Dim colorValues(bytes8 - 1) As Byte ' un array che conterrà tutti i bytes della bitmap.
            ' nel vettore colorValues metto i dati dalla locazione ptr che rappresentano clone4bpp
            System.Runtime.InteropServices.Marshal.Copy(ptr8, colorValues, 0, bytes8)
            bmp4bpp = New Bitmap(bmp8bpp.Width, bmp8bpp.Height, Imaging.PixelFormat.Format4bppIndexed)
            ' blocco i bit della bitmap     
            Dim area4 As Rectangle = New Rectangle(0, 0, bmp4bpp.Width, bmp4bpp.Height)
            Dim bmpData4 As System.Drawing.Imaging.BitmapData = bmp4bpp.LockBits(area4, Drawing.Imaging.ImageLockMode.ReadWrite, bmp4bpp.PixelFormat)
            palette8 = bmp4bpp.Palette
            'creo una palette con 16 livelli di grigio
            For i = 0 To palette8.Entries.Length - 1
                If i > 7 Then
                    palette8.Entries(i) = Color.Black
                Else
                    palette8.Entries(i) = Color.FromArgb(i * 36.4, i * 36.4, i * 36.4)
                    Vbar(i).Value = i * 36.4 ' metto il valore negli slider
                End If
            Next i
            bmp4bpp.Palette = palette8
            Dim ptr4 As IntPtr = bmpData4.Scan0
            Dim bytes4 As Long = Math.Abs(bmpData4.Stride) * bmp4bpp.Height ' calcolo dei bytes necessari
            Dim levelValues(bytes4 - 1) As Byte
            ' In base alle dimensioni il vettore a 4bpp, non sempre viene la metà del vettore a 8bpp
            Dim correttivo As Single = levelValues.Length / (bmpData8.Stride * bmp8bpp.Height / 2)
            Dim ind8 As Integer = 0
            Dim ind4 As Integer = 0
            For riga = 0 To bmp8bpp.Height + 1
                For colonna = 0 To bmp8bpp.Width + 1
                    ind8 = colonna + riga * (bmpData8.Stride - 2)  ' calcolo l'indice per colorValues
                    ind4 = Math.Truncate((ind8 \ 2) * correttivo)  ' calcolo l'indice per levelValues (correttivo non è sempre perfetto)
                    If ind4 > levelValues.GetUpperBound(0) Or ind8 > colorValues.GetUpperBound(0) Then Exit For
                    If ind8 Mod 2 = 0 Then ' ind8 pari, per il pixel a sinistra
                        levelValues(ind4) = (colorValues(ind8) \ 31.8) << 4 ' scrivo a destra ma poi scorrimento a sinistra (come moltiplicare per 16)
                    Else ' ind8 dispari, per il pixel a destra
                        Dim semibyteSinistro As Byte = levelValues(ind4) ' il vecchio pixel a sinistra
                        Dim semibyteDestro As Byte = colorValues(ind8) \ 31.8 ' il nuovo pixel che deve andare a destra
                        levelValues(ind4) = semibyteSinistro + semibyteDestro ' ricompongo il byte con i due pixel
                    End If
                Next
            Next
            'ripristino vettore su immagine
            System.Runtime.InteropServices.Marshal.Copy(colorValues, 0, ptr8, bytes8)
            bmp8bpp.UnlockBits(bmpData8) ' sblocco bit
            PictureBox1.Image = bmp8bpp
            ' ripristino vettore su immagine
            System.Runtime.InteropServices.Marshal.Copy(levelValues, 0, ptr4, bytes4)
            bmp4bpp.UnlockBits(bmpData4) ' sblocco bit
            PictureBox2.Image = bmp4bpp
        End If
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Vbar(0) = VScrollBar0
        Vbar(1) = VScrollBar1
        Vbar(2) = VScrollBar2
        Vbar(3) = VScrollBar3
        Vbar(4) = VScrollBar4
        Vbar(5) = VScrollBar5
        Vbar(6) = VScrollBar6
        Vbar(7) = VScrollBar7
    End Sub

    Private Sub VScrollBar_Scroll(sender As Object, e As ScrollEventArgs) Handles VScrollBar0.Scroll, VScrollBar1.Scroll, VScrollBar2.Scroll, VScrollBar3.Scroll, VScrollBar4.Scroll, VScrollBar5.Scroll, VScrollBar6.Scroll, VScrollBar7.Scroll
        palette8.Entries(CType(sender.tag, Integer)) = Color.FromArgb(e.NewValue, e.NewValue, e.NewValue)
        bmp4bpp.Palette = palette8
        PictureBox2.Image = bmp4bpp
    End Sub
End Class
